#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin:~/diet-pc/tools'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xzf mt-daapd-0.2.4.2.tar.gz
    cd mt-daapd-0.2.4.2
    ed -s configure >/dev/null <<EOF
/{CPPFLAGS} -g/d
w
q
EOF
    ./configure --prefix=/usr --sysconfdir=/etc
    make
    cd src
    gcc -o mt-daapd *.o -lpthread -lz -Wl,-Bstatic -lgdbm -lid3tag \
	    -Wl,-Bdynamic
    strip -R .note -R .comment mt-daapd
    cd ..
    mkdir -p ../mt-daapd/sbin ../mt-daapd/share/mt-daapd
    cp src/mt-daapd ../mt-daapd/sbin/
    cp -r admin-root ../mt-daapd/share/mt-daapd/
    cd ..
    rm -rf mt-daapd-0.2.4.2
}

chmod 0600 mt-daapd/etc/mt-daapd.conf

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
